diff --git a/git.te b/git.te
index 58c3c61..511175b 100644
--- a/git.te
+++ b/git.te
@@ -108,6 +108,8 @@ corenet_tcp_bind_git_port(git_session_t)
 corenet_tcp_sendrecv_git_port(git_session_t)
 corenet_sendrecv_git_server_packets(git_session_t)
 
+auth_use_nsswitch(git_session_t)
+
 userdom_use_user_terminals(git_session_t)
 
 tunable_policy(`git_session_send_syslog_msg',`
@@ -135,6 +137,8 @@ list_dirs_pattern(git_system_t, git_sys_content_t, git_sys_content_t)
 read_files_pattern(git_system_t, git_sys_content_t, git_sys_content_t)
 files_search_var_lib(git_system_t)
 
+auth_use_nsswitch(git_system_t)
+
 logging_send_syslog_msg(git_system_t)
 
 tunable_policy(`git_system_enable_homedirs',`
@@ -221,6 +225,4 @@ files_read_usr_files(git_daemon)
 
 fs_search_auto_mountpoints(git_daemon)
 
-auth_use_nsswitch(git_daemon)
-
 miscfiles_read_localization(git_daemon)
diff --git a/telepathy.if b/telepathy.if
index 6bf75ef..f09171e 100644
--- a/telepathy.if
+++ b/telepathy.if
@@ -24,6 +24,9 @@ template(`telepathy_domain_template',`
 
 	type telepathy_$1_tmp_t;
 	userdom_user_tmp_file(telepathy_$1_tmp_t)
+
+	auth_use_nsswitch(telepathy_$1_t)
+
 ')
 
 #######################################
diff --git a/telepathy.te b/telepathy.te
index ad6a38d..59809b7 100644
--- a/telepathy.te
+++ b/telepathy.te
@@ -367,8 +367,6 @@ kernel_read_system_state(telepathy_domain)
 
 fs_search_auto_mountpoints(telepathy_domain)
 
-auth_use_nsswitch(telepathy_domain)
-
 miscfiles_read_localization(telepathy_domain)
 
 optional_policy(`
diff --git a/virt.if b/virt.if
index 7c5d8d8..6f0736b 100644
--- a/virt.if
+++ b/virt.if
@@ -69,6 +69,8 @@ template(`virt_domain_template',`
 	files_pid_filetrans($1_t, $1_var_run_t, { dir file })
 	stream_connect_pattern($1_t, $1_var_run_t, $1_var_run_t, virtd_t)
 
+	auth_use_nsswitch($1_t)
+
 	optional_policy(`
 		xserver_rw_shm($1_t)
 	')
diff --git a/virt.te b/virt.te
index ad3068a..2976bc0 100644
--- a/virt.te
+++ b/virt.te
@@ -455,8 +455,6 @@ term_getattr_pty_fs(virt_domain)
 term_use_generic_ptys(virt_domain)
 term_use_ptmx(virt_domain)
 
-auth_use_nsswitch(virt_domain)
-
 logging_send_syslog_msg(virt_domain)
 
 miscfiles_read_localization(virt_domain)
diff --git a/zarafa.te b/zarafa.te
index 9fb4747..1a7d9bf 100644
--- a/zarafa.te
+++ b/zarafa.te
@@ -41,6 +41,8 @@ manage_dirs_pattern(zarafa_deliver_t, zarafa_deliver_tmp_t, zarafa_deliver_tmp_t
 manage_files_pattern(zarafa_deliver_t, zarafa_deliver_tmp_t, zarafa_deliver_tmp_t)
 files_tmp_filetrans(zarafa_deliver_t, zarafa_deliver_tmp_t, { file dir })
 
+auth_use_nsswitch(zarafa_deliver_t)
+
 ########################################
 #
 # zarafa_gateway local policy
@@ -57,6 +59,8 @@ corenet_tcp_sendrecv_all_ports(zarafa_gateway_t)
 corenet_tcp_bind_generic_node(zarafa_gateway_t)
 corenet_tcp_bind_pop_port(zarafa_gateway_t)
 
+auth_use_nsswitch(zarafa_gateway_t)
+
 #######################################
 #
 # zarafa-ical local policy
@@ -72,6 +76,8 @@ corenet_tcp_sendrecv_all_ports(zarafa_ical_t)
 corenet_tcp_bind_generic_node(zarafa_ical_t)
 corenet_tcp_bind_http_cache_port(zarafa_ical_t)
 
+auth_use_nsswitch(zarafa_ical_t)
+
 ######################################
 #
 # zarafa-monitor local policy
@@ -79,6 +85,8 @@ corenet_tcp_bind_http_cache_port(zarafa_ical_t)
 
 allow zarafa_monitor_t self:capability chown;
 
+auth_use_nsswitch(zarafa_monitor_t)
+
 ########################################
 #
 # zarafa_server local policy
@@ -107,6 +115,8 @@ corenet_tcp_bind_zarafa_port(zarafa_server_t)
 
 files_read_usr_files(zarafa_server_t)
 
+auth_use_nsswitch(zarafa_server_t)
+
 logging_send_syslog_msg(zarafa_server_t)
 logging_send_audit_msgs(zarafa_server_t)
 
@@ -136,6 +146,8 @@ corenet_tcp_sendrecv_generic_node(zarafa_spooler_t)
 corenet_tcp_sendrecv_all_ports(zarafa_spooler_t)
 corenet_tcp_connect_smtp_port(zarafa_spooler_t)
 
+auth_use_nsswitch(zarafa_spooler_t)
+
 ########################################
 #
 # zarafa domains local policy
@@ -156,6 +168,4 @@ kernel_read_system_state(zarafa_domain)
 
 files_read_etc_files(zarafa_domain)
 
-auth_use_nsswitch(zarafa_domain)
-
 miscfiles_read_localization(zarafa_domain)
